<link rel="import" href="/bower_components/polymer/polymer-element.html">
<link rel="import" href="../l1page-theme/l1page-theme.html">
<link rel="import" href="../toast-manager/when-life-gives-you-lemons-make-toast.html">
<link rel="import" href="/bower_components/paper-input/paper-input.html">
<link rel="import" href="/bower_components/paper-button/paper-button.html">

<!--
     `<trigger-rates>` is not documented properly yet
-->
<dom-module id="trigger-rates">
  <template>
    <link rel="stylesheet" href="trigger-rates.css?__inline=true">
    <style include="l1page-theme"></style>

    <app-route route={{route}} pattern="/rates" data="{{urlData}}"></app-route>
    <l1page-api url="/api/v0/rates/global" data="{{globalRatesData}}" auto></l1page-api>
    <l1page-api url="/api/v0/rates/muon" data="{{muonRatesData}}" auto></l1page-api>
    <l1page-api url="/api/v0/rates/calo" data="{{caloRatesData}}" auto></l1page-api>
    <l1page-api url="/api/v0/rates/thresholds" data="{{thresholdData}}" auto></l1page-api>

<!-- kept for toolbar margin -->
    <header>
    </header>

    <div flex>
      <section no-content hide$="[[!_isEmpty(globalRatesData, runData.triggerState)]]">
        <img src="/elements/l1-page/island.svg">
        <h3 hide$=[[!isInRun(runData.triggerState)]]>Rates will be soon available</h3>
        <h3 hide$=[[isInRun(runData.triggerState)]]>Rates are only available during a run</h3>
        <paper-item on-click="backToHome" >Back to Home</paper-item>
      </section>
    </div>

    <div flex>
      <template is="dom-if" if="{{isLoaded(globalRatesData)}}" restamp=true>
        <section global>
          <div content>
            <div topinfo>
              <h2 wrap nomargin>[[_displaySystem('Global Algorithms', globalRatesData.lumisection)]]</h2>
              <template is="dom-if" if="{{_hasHighTriggerRate(globalRatesData.rates, thresholdData)}}" restamp=true>
                <p high>Some global trigger rates are too HIGH! Scroll down to find triggers with pink background color.</p>

              </template>
              <div nomargin>
                <paper-input FilterInput label="Filter" no-label-float value="{{filterGlobalRates}}"></paper-input>
              </div>
              <table>
                <tr>
                  <th tableheader namecolumn wrap>
                    <span>Algorithm Name</span>
                    <iron-icon SortIcon icon="icons:expand-more" hidden$="{{!sortGlobalByName}}"></iron-icon>
                    <paper-button SortButton hidden$="{{sortGlobalByName}}" on-click="_setSortName">sort</paper-button>
                  </th>
                  <th tableheader rateheader>
                    after-PS<br>Rate (Hz)
                    <iron-icon SortIcon icon="icons:expand-more" hidden$="{{sortGlobalByName}}"></iron-icon>
                    <paper-button SortButton hidden$="{{!sortGlobalByName}}" on-click="_setSortRate">sort</paper-button>
                  </th>
                  <th tableheader rateheader>before-PS<br>Rate (Hz)</th>
                </tr>
              </table>
            </div>


            <div ratetable>
              <table>
                <template is="dom-repeat" items="[[globalRatesData.rates]]" as="globalAlgoRate" filter="{{_filterTriggerName(filterGlobalRates)}}" sort="{{_sortGlobal(sortGlobalByName)}}">
                  <tr threshold$=[[_passGlobalThreshold(globalAlgoRate.RATE,thresholdData)]]>
                    <td namecolumn nameentry>[[globalAlgoRate.NAME]]</td>
                    <td ratecolumn>[[_displayRateGlobal(globalAlgoRate, 'post-PS\, pre-DT')]]</td>
                    <td ratecolumn>[[_displayRateGlobal(globalAlgoRate, 'pre-PS\, pre-DT')]]</td>
                  </tr>
                </template>
              </table>
            </div>


          </div>
        </section>
      </template>

      <template is="dom-if" if="{{isLoaded(muonRatesData)}}" restamp=true>
        <section muon>
          <div content>
            <div topinfo>
              <h2 wrap>[[_displaySystem('Muon System', muonRatesData.lumisection)]]</h2>
              <template is="dom-if" if="{{_hasHighTriggerRate(muonRatesData.rates, thresholdData)}}" restamp=true>
                <p high>Some muon trigger rates are too HIGH! Scroll down to find triggers with pink background color.</p>
              </template>
              <template is="dom-if" if="{{_hasLowTriggerRate(muonRatesData.rates, thresholdData)}}" restamp=true>
                <p low>Some muon trigger rates are too LOW! Scroll down to find triggers with yellow background color.</p>

              </template>
              <table>
                <tr>
                  <th tableheader namecolumn wrap>Regional Rate</th>
                  <th tableheader rateheader>pre-PS, pre-DT<br>Rate(Hz)</th>
                </tr>
              </table>
            </div>
            <div ratetable>
              <table>
                <template is="dom-repeat" items="{{muonSubsystems}}" as="subsystems" >
                  <template is="dom-if" if="{{_displaySubsystemName(subsystems)}}" restamp=true>
                    <tr>
                      <th subsystem tableheader namecolumn>[[subsystems]]</th>
                      <th tableheader></th>
                    </tr>
                  </template>
                  <template is="dom-repeat" items="[[muonRatesData.rates]]" as="muonAlgoRate" filter="{{_subsystemFilter(subsystems)}}" sort="{{_sortMuon(subsystems)}}">
                    <tr threshold$=[[_passThreshold(muonAlgoRate.RATE,thresholdData)]]>
                      <td namecolumn nameentry>[[_displayName(muonAlgoRate.NAME)]]</td>
                      <td ratecolumn>[[_displayRate(muonAlgoRate.RATE)]]</td>
                    </tr>
                  </template>
                </template>
              </table>
            </div>
          </div>
        </section>
      </template>


      <template is="dom-if" if="{{isLoaded(caloRatesData)}}" restamp=true>
        <section calo>
          <h2 wrap>[[_displaySystem('Calo System', caloRatesData.lumisection)]]</h2>
          <template is="dom-if" if="{{_hasHighTriggerRate(caloRatesData.rates, thresholdData)}}" restamp=true>
            <p high>Some calo trigger rates are too HIGH! Scroll down to find triggers with pink background color.</p>
          </template>
          <template is="dom-if" if="{{_hasLowTriggerRate(caloRatesData.rates, thresholdData)}}" restamp=true>
            <p low>Some calo trigger rates are too LOW! Scroll down to find triggers with yellow background color.</p>
          </template>
          <!-- TO FILL WHEN CALO RATES ARE ACTUALLY PRESENT -->
        </section>
      </template>

    </div>
    <slot></slot>
  </template>
</dom-module>

<script src="trigger-rates.js?__inline=true"></script>
